#ifndef __DBG_H__
#define __DBG_H__
#include "afcore.h"
#include "pCOM.h"

#ifdef WIN32
#ifdef _DEBUG
//Comment out this #define if you don't want to write to a file
#define DEBUG_FILE "C:\\OReillyWork\\FinalDraft\\Chap9_Piedmont\\debug.txt"
#endif //_DEBUG
#else //WIN32
//for Palm, define _DEBUG manually
#define _DEBUG
#endif

#ifdef _DEBUG
  
  class CTraceCall
  {
     public:
        CTraceCall(char *msg);
        ~CTraceCall();
     private:
        char m_szMsg[64];
        char m_szOut[128];
  };
  
  void _Debug(IString *msg);
  void _Debugln(IString *msg);
  void _Debugln(char *format, ...);
  void _Debug(char *format, ...);

#define Debug   ::_Debug
#define Debugln ::_Debugln

#else
  inline void _Debugln(IString *msg) {}
  inline void _Debug(IString *msg) {}
  inline void _Debugln(char *format, ...) {}
  inline void _Debug(char *format, ...) {}

//Optimization approach taken from AFX.H, part of Microsoft's MFC distribution
#define Debug   1 ? (void)0 : ::_Debug
#define Debugln 1 ? (void)0 : ::_Debugln
  
#endif //_DEBUG

#endif //__DBG_H__